- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# osg::FragmentProgram Class Reference

FragmentProgram - encapsulates the OpenGL ARB fragment program state. More...

Inheritance diagram for osg::FragmentProgram:

[legend]
List of all members.

## Public Types
typedef std::map< GLuint, Vec4 > | LocalParamList
## Public Member Functions
| FragmentProgram ()
| FragmentProgram (const FragmentProgram &vp, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
| META_StateAttribute (osg, FragmentProgram, FRAGMENTPROGRAM)
virtual int | compare (const osg::StateAttribute &sa) const
| return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
virtual bool | getModeUsage (ModeUsage &usage) const
GLuint & | getFragmentProgramID (unsigned int contextID) const
| Get the handle to the fragment program id for the current context.
void | setFragmentProgram (const std::string &program)
| Set the fragment program using C++ style string.
void | setFragmentProgram (const char *program)
| Set the fragment program using a C style string.
const std::string & | getFragmentProgram () const
| Get the fragment program.
void | setProgramLocalParameter (const GLuint index, const Vec4 &p)
| Set Program Parameters.
LocalParamList & | getLocalParamList ()
| Get list of Program Parameters.
const LocalParamList & | getLocalParamList () const
| Get const list of Program Parameters.
void | setMatrix (const GLenum mode, const Matrix &matrix)
| Matrix.
void | dirtyFragmentProgramObject ()
| Force a recompile on next apply() of associated OpenGL vertex program objects.
virtual void | apply (State &state) const
| apply the OpenGL state attributes.
virtual void | compileGLObjects (State &state) const
| default to nothing to compile - all state is applied immediately.
virtual void | releaseGLObjects (State *state=0) const
| release an OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objexts for all graphics context if State object pointer == NULL.
## Static Public Member Functions
static void | deleteFragmentProgramObject (unsigned int contextID, GLuint handle)
| use deleteFragmentProgramObject instead of glDeletePrograms to allow OpenGL Fragment Program objects to be cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.
static void | flushDeletedFragmentProgramObjects (unsigned int contextID, double currentTime, double &availableTime)
| flush all the cached fragment programs which need to be deleted in the OpenGL context related to contextID.
static Extensions * | getExtensions (unsigned int contextID, bool createIfNotInitalized)
| Function to call to get the extension of a specified context.
static void | setExtensions (unsigned int contextID, Extensions *extensions)
| setExtensions allows users to override the extensions across graphics contexts.
## Protected Types
typedef buffered_value< GLuint > | FragmentProgramIDList
typedef std::map< GLenum, Matrix > | MatrixList
## Protected Member Functions
virtual | ~FragmentProgram ()
## Protected Attributes
FragmentProgramIDList | _fragmentProgramIDList
std::string | _fragmentProgram
LocalParamList | _programLocalParameters
MatrixList | _matrixList
## Classes
class | Extensions
| Extensions class which encapsulates the querying of extensions and associated function pointers, and provide convenience wrappers to check for the extensions or use the associated functions. More...

## Detailed Description

FragmentProgram - encapsulates the OpenGL ARB fragment program state.

## Member Typedef Documentation

typedef buffered_value<GLuint> osg::FragmentProgram::FragmentProgramIDList`[protected]`

typedef std::map<GLuint,Vec4> osg::FragmentProgram::LocalParamList

typedef std::map<GLenum,Matrix> osg::FragmentProgram::MatrixList`[protected]`

## Constructor & Destructor Documentation

FragmentProgram::FragmentProgram | ( |  | ) |

FragmentProgram::FragmentProgram | ( | const FragmentProgram & | vp,
|  | const CopyOp & | copyop = `CopyOp::SHALLOW_COPY`
| ) |

| Copy constructor using CopyOp to manage deep vs shallow copy.

FragmentProgram::~FragmentProgram | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

void FragmentProgram::apply | ( | State & | state | ) | const`[virtual]`

| apply the OpenGL state attributes. The global state for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state. Implements osg::StateAttribute.

virtual int osg::FragmentProgram::compare | ( | const osg::StateAttribute & | sa | ) | const`[inline, virtual]`

| return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs. Implements osg::StateAttribute.

virtual void osg::FragmentProgram::compileGLObjects | ( | State & | state | ) | const`[inline, virtual]`

| default to nothing to compile - all state is applied immediately. Reimplemented from osg::StateAttribute.

void FragmentProgram::deleteFragmentProgramObject | ( | unsigned int | contextID,
|  | GLuint | handle
| ) | `[static]`

| use deleteFragmentProgramObject instead of glDeletePrograms to allow OpenGL Fragment Program objects to be cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.

void FragmentProgram::dirtyFragmentProgramObject | ( |  | ) |

| Force a recompile on next apply() of associated OpenGL vertex program objects.

void FragmentProgram::flushDeletedFragmentProgramObjects | ( | unsigned int | contextID,
|  | double | currentTime,
|  | double & | availableTime
| ) | `[static]`

| flush all the cached fragment programs which need to be deleted in the OpenGL context related to contextID.

FragmentProgram::Extensions * FragmentProgram::getExtensions | ( | unsigned int | contextID,
|  | bool | createIfNotInitalized
| ) | `[static]`

| Function to call to get the extension of a specified context. If the Extension object for that context has not yet been created and the 'createIfNotInitalized' flag has been set to false then returns NULL. If 'createIfNotInitalized' is true then the Extensions object is automatically created. However, in this case the extension object will only be created with the graphics context associated with ContextID..

const std::string& osg::FragmentProgram::getFragmentProgram | ( |  | ) | const`[inline]`

| Get the fragment program.

GLuint& osg::FragmentProgram::getFragmentProgramID | ( | unsigned int | contextID | ) | const`[inline]`

| Get the handle to the fragment program id for the current context.

const LocalParamList& osg::FragmentProgram::getLocalParamList | ( |  | ) | const`[inline]`

| Get const list of Program Parameters.

LocalParamList& osg::FragmentProgram::getLocalParamList | ( |  | ) | `[inline]`

| Get list of Program Parameters.

virtual bool osg::FragmentProgram::getModeUsage | ( | ModeUsage & | usage | ) | const`[inline, virtual]`

osg::FragmentProgram::META_StateAttribute | ( | osg | ,
|  | FragmentProgram | ,
|  | FRAGMENTPROGRAM |
| ) |

void FragmentProgram::releaseGLObjects | ( | State * | state = `0` | ) | const`[virtual]`

| release an OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objexts for all graphics context if State object pointer == NULL. Reimplemented from osg::StateAttribute.

void FragmentProgram::setExtensions | ( | unsigned int | contextID,
|  | Extensions * | extensions
| ) | `[static]`

| setExtensions allows users to override the extensions across graphics contexts. typically used when you have different extensions supported across graphics pipes but need to ensure that they all use the same low common denominator extensions.

void osg::FragmentProgram::setFragmentProgram | ( | const char * | program | ) | `[inline]`

| Set the fragment program using a C style string.

void osg::FragmentProgram::setFragmentProgram | ( | const std::string & | program | ) | `[inline]`

| Set the fragment program using C++ style string.

void osg::FragmentProgram::setMatrix | ( | const GLenum | mode,
|  | const Matrix & | matrix
| ) | `[inline]`

| Matrix.

void osg::FragmentProgram::setProgramLocalParameter | ( | const GLuint | index,
|  | const Vec4 & | p
| ) | `[inline]`

| Set Program Parameters.

## Member Data Documentation

std::string osg::FragmentProgram::_fragmentProgram`[protected]`

FragmentProgramIDList osg::FragmentProgram::_fragmentProgramIDList`[mutable, protected]`

MatrixList osg::FragmentProgram::_matrixList`[protected]`

LocalParamList osg::FragmentProgram::_programLocalParameters`[protected]`

The documentation for this class was generated from the following files:

- FragmentProgram
- FragmentProgram.cpp